package com.heyang;

import java.util.List;

import com.heyang.util.BracketChecker;
import com.heyang.util.CommonUtil;
import com.heyang.util.Renderer;

public class EntryPoint {
	public static void main(String[] args) throws Exception{
		List<String> ls=CommonUtil.readTextListFromFile("C:\\hy\\files\\math\\math.txt");
		
		for(String exp:ls) {
			calculate(exp);
		}
	}
	
	private static void calculate(String mathExp)  throws Exception{
		// brackets is balanced
		BracketChecker checker=new BracketChecker();
		boolean isBalanced=checker.isBalanced(mathExp);
		if(isBalanced==false) {
			System.out.println(Renderer.paintBrown(checker.getErrMsg()));
			return;
		}
		
		// Split expression into tokens
		Lexer lexer=new Lexer(mathExp);
		// lexer.printTokenList();
		
		// Evaluate
		Evaluator evlt=new Evaluator(lexer.getTokens());
		System.out.println(mathExp+"="+evlt.getResult());
		
		//
		TreeBuilder builder=new TreeBuilder(lexer.getTokens());
		Node root=builder.getRoot();
		TreeOperation.show(root); 
		//root=null;
	}
}
