package com.heyang;

public class Token {
	public static final int TYPE_PLUS=1;
	public static final int TYPE_MINUS=2;
	public static final int TYPE_MULTI=3;
	public static final int TYPE_DIVIDE=4;
	
	public static final int TYPE_LEFT_PAREN=5;
	public static final int TYPE_RIGHT_PAREN=6;
	
	public static final int TYPE_DIGITAL=7;
	
	private int type;
	private String text;
	private double value;
	
	public Token(String text,int type) throws AnalyzerExp{
		this.text=text;
		this.type=type;
		
		try {
			this.value=Double.parseDouble(this.text);
		}catch(NumberFormatException ex) {
			throw new AnalyzerExp(String.format("Can not convert text:%s to double.", this.text));
		}
	}
	
	public Token(char c,int type) {
		this.text=String.valueOf(c);
		this.type=type;
	}
	
	public String toString() {
		if(this.type<TYPE_DIGITAL) {
			return this.text;
		}else {
			return String.valueOf(this.value);
		}
	}

	public int getType() {
		return type;
	}

	public double getValue() {
		return value;
	}
	
	public String getText() {
		return text;
	}
	
	public String getTypeStr() {
		if(type==TYPE_PLUS) {
			return "+";
		}else if(type==TYPE_MINUS){
			return "-";
		}else if(type==TYPE_MULTI){
			return "*";
		}else if(type==TYPE_DIVIDE){
			return "/";
		}else if(type==TYPE_LEFT_PAREN){
			return "(";
		}else if(type==TYPE_RIGHT_PAREN){
			return ")";
		}else if(type==TYPE_DIGITAL){
			return String.valueOf(value);
		}else {
			return "Unknown";
		}
	}
}
